#include<iostream>
#include<cstdio>
#include<vector>
#include<algorithm>
using namespace std;
#define MAX 100
#define MAXGRID 10*10
int n,m,p;
int grid[MAXGRID],r[MAX],c[MAX],k[MAX],t[MAX];
int af[MAX][MAXGRID];

struct passed {
       int a,x,y;
};
vector<passed> animals;
struct data {
       int num,r,c,k,t;
       int gr[MAXGRID];
};

long long safetymax( int posx, int posy, int sizex, int sizey, int *grid1, int safe )
{
    long long sum = 0;
    for( int k = 0; k < sizex; k++ )
    {
         for( int l = 0; l < sizey; l++ )
         {
              if(grid1[k*sizex+l])
              {
                   if( grid[(posx+k)*n+posy+l] < safe )
                       return -1LL;
                   sum+=grid[(posx+k)*n+posy+l];
              }
         }
    }
    return sum;
}

void div( int xpos, int ypos, int sizex, int sizey, int *gr, int coef )
{
     for( int k = 0; k < sizex; k++ )
     {
          for( int j = 0; j < sizey; j++ )
          {
               if(gr[k*sizex+j])
               {
                   grid[(xpos+k)*n+ypos+j] /= coef;
               }
          }
     }
}

bool comp( data a, data b )
{
     if( a.t < b.t )
         return true;
     return false;
}

int main()
{
   freopen( "parash.out", "w", stdout );
   freopen( "parash.in", "r", stdin );
   scanf("%d%d%d", &n, &m, &p);
   int gsize = n*m;
   int asize;
   vector<data> anim;
   for( int i = 0; i < n*m; i++ )
        scanf( "%d", &grid[i] );
   for( int i = 0; i < p; i++ )
   {
        scanf("%d%d%d%d", &r[i], &c[i], &k[i], &t[i] );
	    char line[11];
	    data temp = { i+1, r[i], c[i], k[i], t[i], 0 };
        for( int j = 0; j < r[i]; j++ )
        {
             scanf( "%s", &line );
             for( int k = 0; k < c[i]; k++ )
             {
                  temp.gr[j*r[i]+k]=line[k]-'0';
             }    
        }
        anim.push_back(temp);
   }
   stable_sort( anim.begin(), anim.begin()+p, comp );

   for( int i = 0; i < p; i++ )
   {
        int xmax = -1;
        int ymax = -1;
        long long maxsafety = -1LL;
        for( int k = 0; k <= n-anim[i].r; k++ )
        {
             for( int j = 0; j <= m-anim[i].c; j++ )
             {
                  long long res = safetymax( k, j, anim[i].r, anim[i].c, anim[i].gr, anim[i].t );
                  if( res != -1LL )
                  {
                      if( res > maxsafety )
                      {
                          xmax = k+1;
                          ymax = j+1;
                          maxsafety = res;
                      }
                  }
             }
        }
        if( xmax != -1 && ymax != -1 && maxsafety != -1 )
        {
            passed temp = { anim[i].num, xmax, ymax };
            animals.push_back(temp);
            div( xmax-1, ymax-1, anim[i].r, anim[i].c, anim[i].gr, anim[i].k );
        }
   }
   printf( "%d\n", animals.size());
   for( int i = 0; i < animals.size(); i++ )
        printf("%d %d %d\n", animals[i].a, animals[i].x, animals[i].y);
   return 0;
}
